## igraph 0.10.13+ds

=== debian/changelog ===
igraph (0.10.13+ds-2) unstable; urgency=medium

  * Debianization:
    - d/patches/*:
      - -d/p/upstream-fix-multiarch-file_conflict.patch, correct
         (thanks to Szabolcs Horvat <szhorvat@gmail.com> for the correction).

 -- Jerome Benoit <calculus@rezozer.net>  Mon, 15 Jul 2024 21:11:34 +0000

igraph (0.10.13+ds-1) unstable; urgency=medium

  * New upstream micro version.
  * Debianization:
    - d/libigraph3t64.symbols, update;
    - d/patches/*:
      - d/p/upstream-silence-tests-benchmarks-{format_truncation,
        unused_but_set_variable}.patch, introduce;
    - various minor janitorial changes.

 -- Jerome Benoit <calculus@rezozer.net>  Fri, 28 Jun 2024 20:51:42 +0000

igraph (0.10.12+ds-1) unstable; urgency=medium

  * New upstream micro version.
  * Debianization:
    - d/libigraph3t64.symbols, update.

 -- Jerome Benoit <calculus@rezozer.net>  Thu, 09 May 2024 18:27:31 +0000

igraph (0.10.11+ds-1) unstable; urgency=medium

  * New upstream micro version.
  * Debianization:
    - d/libigraph3t64.symbols, update;
    - d/libigraph-doc.docs, add CONTRIBUTORS.txt.

 -- Jerome Benoit <calculus@rezozer.net>  Wed, 03 Apr 2024 10:29:04 +0000

=== debian/control ===
Source: igraph
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Jerome Benoit <calculus@rezozer.net>,
           Andreas Tille <tille@debian.org>
Section: science
Priority: optional
Build-Depends: dpkg-dev (>= 1.22.5), debhelper-compat (= 13),
               cmake,
               d-shlibs,
               bison,
               flex,
               libxml2-dev,
               libplfit-dev,
               libgmp-dev,
               libarpack2-dev,
               libblas-dev,
               liblapack-dev,
               libglpk-dev,
               libf2c2-dev,
               liblzma-dev
Build-Depends-Indep: python3,
                     xmlto,
                     source-highlight,
                     fop,
                     fonts-font-awesome,
                     libxml2-utils,
                     docbook2x,
                     texinfo
Standards-Version: 4.6.2
Vcs-Browser: https://salsa.debian.org/med-team/igraph
Vcs-Git: https://salsa.debian.org/med-team/igraph.git
Homepage: https://igraph.org/c/
Rules-Requires-Root: no

Package: libigraph3t64
Provides: ${t64:Provides}
Replaces: libigraph3
Breaks: libigraph3 (<< ${source:Version})
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: library for creating and manipulating graphs
 igraph is a library for creating and manipulating graphs.
 It is intended to be as powerful (ie. fast) as possible to enable the
 analysis of large graphs.
 .
 This is the runtime library package.

Package: libigraph-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libigraph3t64 (= ${binary:Version}),
         libxml2-dev,
         ${devlibs:Depends},
         ${misc:Depends}
Suggests: libigraph-doc,
          pkgconf
Description: library for creating and manipulating graphs - development files
 igraph is a library for creating and manipulating graphs.
 It is intended to be as powerful (ie. fast) as possible to enable the
 analysis of large graphs.
 .
 This package contains the include files and static library for the igraph
 C library.

Package: libigraph-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: fonts-font-awesome,
         ${misc:Depends}
Suggests: libigraph-dev (= ${binary:Version}),
          libsuitesparse-dev,
          www-browser
Breaks: libigraph-examples (<< 0.9)
Replaces: libigraph-examples (<< 0.9)
Description: library for creating and manipulating graphs - reference manual
 igraph is a library for creating and manipulating graphs.
 It is intended to be as powerful (ie. fast) as possible to enable the
 analysis of large graphs.
 .
 This package provides the reference manual for the igraph C library;
 it also contains examples and tutorial material.

Package: libigraph-examples
Architecture: all
Multi-Arch: foreign
Section: oldlibs
Depends: libigraph-doc,
         ${misc:Depends}
Description: transitional package
 This is a transitional package. It can safely be removed.

## igraph 0.10.15+ds

=== CMakeLists.txt ===
# Minimum CMake that we require is 3.18.
# Some of the recent features we use:
#  * --ignore-eol when comparing unit test results with expected outcomes (3.14)
#  * CROSSCOMPILING_EMULATOR can be a semicolon-separated list to pass arguments (3.15)
#  * SKIP_REGULAR_EXPRESSION to handle skipped tests properly (3.16)
#  * CheckLinkerFlag for HAVE_NEW_DTAGS test (3.18)
#  * cmake -E cat (3.18)
cmake_minimum_required(VERSION 3.18...3.30)

# Add etc/cmake to CMake's search path so we can put our private stuff there
list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_LIST_DIR}/etc/cmake)

# Set a default build type if none was specified
# This must precede the project() line, which would set the CMAKE_BUILD_TYPE
# to 'Debug' with single-config generators on Windows.
# Note that we must do this only if PROJECT_NAME is not set at this point. If
# it is set, it means that igraph is being used as a subproject of another
# project.
if(NOT PROJECT_NAME)
  include(BuildType)
endif()

# Prevent in-source builds
include(PreventInSourceBuilds)

# Make use of ccache if it is present on the host system -- unless explicitly
# asked to disable it
include(UseCCacheWhenInstalled)

# Figure out the version number from Git
include(version)

# Declare the project, its version number and language
project(
  igraph
  VERSION ${PACKAGE_VERSION_BASE}
  DESCRIPTION "A library for creating and manipulating graphs"
  HOMEPAGE_URL https://igraph.org
  LANGUAGES C CXX
)

# Include some compiler-related helpers and set global compiler options
include(compilers)

# Detect is certain attributes are supported by the compiler
include(attribute_support)

# Set default symbol visibility to hidden
set(CMAKE_C_VISIBILITY_PRESET hidden)
set(CMAKE_CXX_VISIBILITY_PRESET hidden)

# Set C and C++ standard version
set(CMAKE_C_STANDARD 99)
set(CMAKE_C_STANDARD_REQUIRED True)
set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED True)

# Expose the BUILD_SHARED_LIBS option in the ccmake UI
option(BUILD_SHARED_LIBS "Build shared libraries" OFF)

# Add switches to use sanitizers and debugging helpers if needed
include(debugging)
include(sanitizers)

# Enable fuzzer instrumentation if needed
# FUZZING_BUILD_MODE_UNSAFE_FOR_PRODUCTION is a conventional
# macro used to adapt code for fuzzability, for example by
# reducing largest allowed graph sizes when reading various
# file formats.
if(BUILD_FUZZING)
  add_compile_options(-fsanitize=fuzzer-no-link)
  add_compile_definitions(FUZZING_BUILD_MODE_UNSAFE_FOR_PRODUCTION)
endif()

# Add version information
configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/include/igraph_version.h.in
  ${CMAKE_CURRENT_BINARY_DIR}/include/igraph_version.h
)

# Create configuration options for optional features
include(features)

# Handle dependencies and dependency-related configuration options
include(dependencies)
find_dependencies()

# Run compile-time checks, generate config.h and igraph_threading.h
include(CheckSymbolExists)
include(CheckIncludeFiles)
include(CMakePushCheckState)

# First we check for some functions and symbols
cmake_push_check_state()
if(NEED_LINKING_AGAINST_LIBM)
  list(APPEND CMAKE_REQUIRED_LIBRARIES m)
endif()
check_symbol_exists(strcasecmp strings.h HAVE_STRCASECMP)
check_symbol_exists(strncasecmp strings.h HAVE_STRNCASECMP)
check_symbol_exists(_stricmp string.h HAVE__STRICMP)
check_symbol_exists(_strnicmp string.h HAVE__STRNICMP)
check_symbol_exists(strdup string.h HAVE_STRDUP)
check_symbol_exists(strndup string.h HAVE_STRNDUP)
check_include_files(xlocale.h HAVE_XLOCALE)
if(HAVE_XLOCALE)
  # On BSD, uselocale() is in xlocale.h instead of locale.h.
  # Some systems provide xlocale.h, but uselocale() is still in locale.h,
  # thus we try both.
  check_symbol_exists(uselocale "xlocale.h;locale.h" HAVE_USELOCALE)
else()
  check_symbol_exists(uselocale locale.h HAVE_USELOCALE)
endif()
check_symbol_exists(_configthreadlocale locale.h HAVE__CONFIGTHREADLOCALE)
cmake_pop_check_state()

# Check for 128-bit integer multiplication support, floating-point endianness,
# support for built-in overflow detection and fast bit operation support.
include(ieee754_endianness)
include(uint128_support)
include(bit_operations_support)
include(safe_math_support)

if(NOT HAVE_USELOCALE AND NOT HAVE__CONFIGTHREADLOCALE)
  message(WARNING "igraph cannot set per-thread locale on this platform. igraph_enter_safelocale() and igraph_exit_safelocale() will not be safe to use in multithreaded programs.")
endif()

# Check for code coverage support
option(IGRAPH_ENABLE_CODE_COVERAGE "Enable code coverage calculation" OFF)
if(CMAKE_PROJECT_NAME STREQUAL PROJECT_NAME AND IGRAPH_ENABLE_CODE_COVERAGE)
  include(CodeCoverage)
  append_coverage_compiler_flags()
  setup_target_for_coverage_lcov(
    NAME coverage
    EXECUTABLE "${CMAKE_COMMAND}" "--build" "${PROJECT_BINARY_DIR}" "--target" "check"
    # Generated files are excluded; apparently the CodeCoverage script has some
    # problems with them. Yes, the exclusion is correct, it refers to a nonexistent
    # directory that somehow gets into the coverage results. /Applications and
    # /Library/Developer are for macOS -- they exclude files from the macOS SDK.
    EXCLUDE "io/*.l" "src/io/parsers/*" "io/parsers/*" "/Applications/Xcode*" "/Library/Developer/*" "examples/*" "interfaces/*" "tests/*" "vendor/pcg/*"
  )
endif()

# Generate configuration headers
configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/src/config.h.in
  ${CMAKE_CURRENT_BINARY_DIR}/src/config.h
)
configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/include/igraph_config.h.in
  ${CMAKE_CURRENT_BINARY_DIR}/include/igraph_config.h
)
configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/include/igraph_threading.h.in
  ${CMAKE_CURRENT_BINARY_DIR}/include/igraph_threading.h
)

# Enable unit tests. Behave nicely and do this only if we are not being
# included as a sub-project in another CMake project
if(CMAKE_PROJECT_NAME STREQUAL PROJECT_NAME)
  include(CTest)
endif()

# Traverse subdirectories. vendor/ should come first because code in
# src/CMakeLists.txt depends on targets in vendor/
add_subdirectory(vendor)
add_subdirectory(src)
add_subdirectory(interfaces)
if(CMAKE_PROJECT_NAME STREQUAL PROJECT_NAME AND BUILD_TESTING)
  add_subdirectory(tests)
endif()
if(CMAKE_PROJECT_NAME STREQUAL PROJECT_NAME AND BUILD_FUZZING)
  add_subdirectory(fuzzing)
endif()
if(CMAKE_PROJECT_NAME STREQUAL PROJECT_NAME)
  add_subdirectory(doc)
endif()

# Configure packaging -- only if igraph is the top-level project and not a
# subproject
if(CMAKE_PROJECT_NAME STREQUAL PROJECT_NAME)
  include(packaging)
endif()

# Show result of configuration
include(summary)

=== src/CMakeLists.txt ===

# Traverse subdirectories
add_subdirectory(centrality/prpack)
add_subdirectory(cliques/cliquer)
add_subdirectory(isomorphism/bliss)

# Generate lexers and parsers
set(PARSER_SOURCES)
file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/io/parsers)
foreach(FORMAT dl gml lgl ncol pajek)
  if(EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/io/parsers/${FORMAT}-parser.c)
    list(APPEND PARSER_SOURCES
      ${CMAKE_CURRENT_SOURCE_DIR}/io/parsers/${FORMAT}-lexer.c
      ${CMAKE_CURRENT_SOURCE_DIR}/io/parsers/${FORMAT}-parser.c
    )
  else()
    if (BISON_VERSION VERSION_GREATER_EQUAL 3)
      set(bison_no_deprecated -Wno-deprecated)
    endif()
    if (NOT FLEX_KEEP_LINE_NUMBERS)
      set(bison_hide_line_numbers --no-lines)
      set(flex_hide_line_numbers --noline)
    endif()
    bison_target(
      ${FORMAT}_parser io/${FORMAT}-parser.y ${CMAKE_CURRENT_BINARY_DIR}/io/parsers/${FORMAT}-parser.c
      COMPILE_FLAGS "${bison_hide_line_numbers} ${bison_no_deprecated}"
    )
    flex_target(
      ${FORMAT}_lexer io/${FORMAT}-lexer.l ${CMAKE_CURRENT_BINARY_DIR}/io/parsers/${FORMAT}-lexer.c
      COMPILE_FLAGS "${flex_hide_line_numbers}"
      DEFINES_FILE ${CMAKE_CURRENT_BINARY_DIR}/io/parsers/${FORMAT}-lexer.h
    )
    add_flex_bison_dependency(${FORMAT}_lexer ${FORMAT}_parser)
    list(APPEND PARSER_SOURCES ${BISON_${FORMAT}_parser_OUTPUTS} ${FLEX_${FORMAT}_lexer_OUTPUTS})
  endif()
endforeach()
add_custom_target(parsersources SOURCES ${PARSER_SOURCES})

# Declare the files needed to compile the igraph library
add_library(
  igraph
  core/array.c
  core/bitset.c
  core/bitset_list.c
  core/buckets.c
  core/cutheap.c
  core/dqueue.c
  core/error.c
  core/estack.c
  core/fixed_vectorlist.c
  core/genheap.c
  core/grid.c
  core/heap.c
  core/indheap.c
  core/interruption.c
  core/marked_queue.c
  core/matrix.c
  core/matrix_list.c
  core/memory.c
  core/printing.c
  core/progress.c
  core/psumtree.c
  core/set.c
  core/sparsemat.c
  core/stack.c
  core/statusbar.c
  core/strvector.c
  core/trie.c
  core/vector.c
  core/vector_list.c
  core/vector_ptr.c

  math/complex.c
  math/safe_intop.c
  math/utils.c

  linalg/arpack.c
  linalg/blas.c
  linalg/eigen.c
  linalg/lapack.c

  random/random.c
  random/rng_glibc2.c
  random/rng_mt19937.c
  random/rng_pcg32.c
  random/rng_pcg64.c

  graph/adjlist.c
  graph/attributes.c
  graph/basic_query.c
  graph/caching.c
  graph/cattributes.c
  graph/graph_list.c
  graph/iterators.c
  graph/type_common.c
  graph/type_indexededgelist.c
  graph/visitors.c

  constructors/adjacency.c
  constructors/atlas.c
  constructors/basic_constructors.c
  constructors/circulant.c
  constructors/de_bruijn.c
  constructors/famous.c
  constructors/full.c
  constructors/generalized_petersen.c
  constructors/kautz.c
  constructors/lattices.c
  constructors/lcf.c
  constructors/linegraph.c
  constructors/prufer.c
  constructors/regular.c
  constructors/trees.c


  games/barabasi.c
  games/callaway_traits.c
  games/chung_lu.c
  games/citations.c
  games/correlated.c
  games/degree_sequence_vl/gengraph_degree_sequence.cpp
  games/degree_sequence_vl/gengraph_graph_molloy_hash.cpp
  games/degree_sequence_vl/gengraph_graph_molloy_optimized.cpp
  games/degree_sequence_vl/gengraph_mr-connected.cpp
  games/degree_sequence.c
  games/dotproduct.c
  games/erdos_renyi.c
  games/establishment.c
  games/forestfire.c
  games/grg.c
  games/growing_random.c
  games/islands.c
  games/k_regular.c
  games/preference.c
  games/recent_degree.c
  games/sbm.c
  games/static_fitness.c
  games/tree.c
  games/watts_strogatz.c

  centrality/betweenness.c
  centrality/centrality_other.c
  centrality/centralization.c
  centrality/closeness.c
  centrality/coreness.c
  centrality/eigenvector.c
  centrality/hub_authority.c
  centrality/pagerank.c
  centrality/truss.cpp
  centrality/prpack.cpp

  cliques/cliquer_wrapper.c
  cliques/cliques.c
  cliques/maximal_cliques.c
  cliques/glet.c

  community/community_misc.c
  community/edge_betweenness.c
  community/fast_modularity.c
  community/fluid.c
  community/infomap/infomap_FlowGraph.cc
  community/infomap/infomap_Greedy.cc
  community/infomap/infomap.cc
  community/label_propagation.c
  community/leading_eigenvector.c
  community/leiden.c
  community/louvain.c
  community/modularity.c
  community/optimal_modularity.c
  community/spinglass/clustertool.cpp
  community/spinglass/NetDataTypes.cpp
  community/spinglass/NetRoutines.cpp
  community/spinglass/pottsmodel_2.cpp
  community/voronoi.c
  community/walktrap/walktrap_communities.cpp
  community/walktrap/walktrap_graph.cpp
  community/walktrap/walktrap_heap.cpp
  community/walktrap/walktrap.cpp

  connectivity/cohesive_blocks.c
  connectivity/components.c
  connectivity/separators.c
  connectivity/reachability.c

  cycles/simple_cycles.c

  flow/flow.c
  flow/flow_conversion.c
  flow/st-cuts.c

  hrg/hrg_types.cc
  hrg/hrg.cc

  io/dimacs.c
  io/dl.c
  io/dot.c
  io/edgelist.c
  io/graphml.c
  io/gml-tree.c
  io/gml.c
  io/graphdb.c
  io/leda.c
  io/lgl.c
  io/ncol.c
  io/pajek.c
  io/parse_utils.c
  ${PARSER_SOURCES}

  layout/circular.c
  layout/davidson_harel.c
  layout/drl/DensityGrid.cpp
  layout/drl/DensityGrid_3d.cpp
  layout/drl/drl_graph.cpp
  layout/drl/drl_graph_3d.cpp
  layout/drl/drl_layout.cpp
  layout/drl/drl_layout_3d.cpp
  layout/fruchterman_reingold.c
  layout/gem.c
  layout/graphopt.c
  layout/kamada_kawai.c
  layout/large_graph.c
  layout/layout_bipartite.c
  layout/layout_grid.c
  layout/layout_random.c
  layout/mds.c
  layout/merge_dla.c
  layout/merge_grid.c
  layout/reingold_tilford.c
  layout/sugiyama.c
  layout/umap.c

  operators/add_edge.c
  operators/complementer.c
  operators/compose.c
  operators/connect_neighborhood.c
  operators/contract.c
  operators/difference.c
  operators/disjoint_union.c
  operators/intersection.c
  operators/join.c
  operators/misc_internal.c
  operators/permute.c
  operators/reverse.c
  operators/rewire.c
  operators/rewire_edges.c
  operators/simplify.c
  operators/subgraph.c
  operators/union.c

  paths/all_shortest_paths.c
  paths/astar.c
  paths/bellman_ford.c
  paths/dijkstra.c
  paths/distances.c
  paths/eulerian.c
  paths/floyd_warshall.c
  paths/histogram.c
  paths/johnson.c
  paths/random_walk.c
  paths/shortest_paths.c
  paths/simple_paths.c
  paths/sparsifier.c
  paths/unweighted.c
  paths/voronoi.c
  paths/widest_paths.c

  properties/basic_properties.c
  properties/complete.c
  properties/constraint.c
  properties/convergence_degree.c
  properties/dag.c
  properties/degrees.c
  properties/ecc.c
  properties/girth.c
  properties/loops.c
  properties/multiplicity.c
  properties/neighborhood.c
  properties/perfect.c
  properties/spectral.c
  properties/trees.c
  properties/triangles.c

  isomorphism/bliss.cc
  isomorphism/isoclasses.c
  isomorphism/lad.c
  isomorphism/isomorphism_misc.c
  isomorphism/queries.c
  isomorphism/vf2.c

  misc/bipartite.c
  misc/chordality.c
  misc/cocitation.c
  misc/coloring.c
  misc/conversion.c
  misc/cycle_bases.c
  misc/degree_sequence.cpp
  misc/embedding.c
  misc/feedback_arc_set.c
  misc/graphicality.c
  misc/matching.c
  misc/microscopic_update.c
  misc/mixing.c
  misc/motifs.c
  misc/order_cycle.cpp
  misc/other.c
  misc/power_law_fit.c
  misc/scan.c
  misc/sir.c
  misc/spanning_trees.c

  internal/glpk_support.c
  internal/hacks.c
  internal/lsap.c
  internal/qsort_r.c
  internal/qsort.c
  internal/utils.c
  internal/zeroin.c

  version.c

  # Vendored library sources. Yes, this is horrible.
  $<IF:$<OR:$<BOOL:${ARPACK_IS_VENDORED}>,$<BOOL:${BLAS_IS_VENDORED}>,$<BOOL:${LAPACK_IS_VENDORED}>>,$<TARGET_OBJECTS:f2c_vendored>,>
  $<IF:$<BOOL:${ARPACK_IS_VENDORED}>,$<TARGET_OBJECTS:arpack_vendored>,>
  $<IF:$<BOOL:${BLAS_IS_VENDORED}>,$<TARGET_OBJECTS:blas_vendored>,>
  $<IF:$<BOOL:${GLPK_IS_VENDORED}>,$<TARGET_OBJECTS:glpk_vendored>,>
  $<IF:$<BOOL:${GMP_IS_VENDORED}>,$<TARGET_OBJECTS:gmp_vendored>,>
  $<IF:$<BOOL:${LAPACK_IS_VENDORED}>,$<TARGET_OBJECTS:lapack_vendored>,>
  $<IF:$<BOOL:${PLFIT_IS_VENDORED}>,$<TARGET_OBJECTS:plfit_vendored>,>
)

# Required by Xcode new build system
add_dependencies(igraph parsersources)

# Set soname for the library
set_target_properties(igraph PROPERTIES VERSION "3.1.9")
set_target_properties(igraph PROPERTIES SOVERSION 3)

# Add extra compiler definitions if needed
target_compile_definitions(
  igraph
  PRIVATE
  IGRAPH_VERIFY_FINALLY_STACK=$<IF:$<BOOL:${IGRAPH_VERIFY_FINALLY_STACK}>,1,0>
)
# target_compile_options(
#   # -Wconversion could be useful?
#   igraph PRIVATE -Wshorten-64-to-32
# )

# Make sure that a macro named IGRAPH_FILE_BASENAME is provided in every
# compiler call so we can use these in debug messages without revealing the
# full path of the file on the machine where it was compiled
define_file_basename_for_sources(igraph)

# Add include path. Includes are in ../include but they get installed to
# <prefix>/include/igraph, hence the two options. We also have some private
# includes that are generated at compile time but are not part of the public
# interface.
target_include_directories(
  igraph
  PUBLIC
  $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
  $<BUILD_INTERFACE:${PROJECT_BINARY_DIR}/include>
  $<INSTALL_INTERFACE:include/igraph>
  PRIVATE
  ${CMAKE_CURRENT_BINARY_DIR}
  ${CMAKE_CURRENT_SOURCE_DIR}
  ${PROJECT_SOURCE_DIR}/vendor

  # Vendored library include paths
  "$<$<BOOL:${GLPK_IS_VENDORED}>:$<TARGET_PROPERTY:glpk_vendored,INCLUDE_DIRECTORIES>>"
  "$<$<BOOL:${PLFIT_IS_VENDORED}>:$<TARGET_PROPERTY:plfit_vendored,INCLUDE_DIRECTORIES>>"

  # Include paths for dependencies
  "$<$<BOOL:${GLPK_INCLUDE_DIR}>:${GLPK_INCLUDE_DIR}>"
  "$<$<BOOL:${GMP_INCLUDE_DIR}>:${GMP_INCLUDE_DIR}>"
  "$<$<BOOL:${LIBXML2_INCLUDE_DIRS}>:${LIBXML2_INCLUDE_DIRS}>"
  "$<$<BOOL:${PLFIT_INCLUDE_DIRS}>:${PLFIT_INCLUDE_DIRS}>"
)

if(MATH_LIBRARY)
  target_link_libraries(igraph PUBLIC ${MATH_LIBRARY})
endif()

if(ARPACK_LIBRARIES)
  target_link_libraries(igraph PRIVATE ${ARPACK_LIBRARIES})
endif()

if(BLAS_FOUND)
  target_link_libraries(igraph PRIVATE ${BLAS_LIBRARIES})
endif()

if(GLPK_LIBRARIES)
  target_link_libraries(igraph PRIVATE ${GLPK_LIBRARIES})
endif()

if(GMP_LIBRARIES)
  target_link_libraries(igraph PRIVATE ${GMP_LIBRARIES})
endif()

if(LAPACK_LIBRARIES)
  target_link_libraries(igraph PRIVATE ${LAPACK_LIBRARIES})
endif()

if(LIBXML2_LIBRARIES)
  target_link_libraries(igraph PRIVATE ${LIBXML2_LIBRARIES})
endif()

if(PLFIT_LIBRARIES)
  target_link_libraries(igraph PRIVATE ${PLFIT_LIBRARIES})
endif()

# Link igraph statically to some of the libraries from the subdirectories
target_link_libraries(
  igraph
  PRIVATE
  bliss cliquer cxsparse_vendored pcg prpack
)

if (NOT BUILD_SHARED_LIBS)
  target_compile_definitions(igraph PUBLIC IGRAPH_STATIC)
else()
  target_compile_definitions(igraph PRIVATE igraph_EXPORTS)
endif()

if(MSVC)
  # Add MSVC-specific include path for some headers that are missing on Windows
  target_include_directories(igraph PRIVATE ${PROJECT_SOURCE_DIR}/msvc/include)
endif()

# Turn on all warnings for GCC, clang and MSVC
use_all_warnings(igraph)

# GNUInstallDirs be included before generating the pkgconfig file, as it defines
# CMAKE_INSTALL_LIBDIR and CMAKE_INSTALL_INCLUDEDIR variables.
include(GNUInstallDirs)

# Generate pkgconfig file
include(pkgconfig_helpers)

include(GenerateExportHeader)
generate_export_header(igraph
  STATIC_DEFINE IGRAPH_STATIC
  EXPORT_FILE_NAME ${PROJECT_BINARY_DIR}/include/igraph_export.h
)

# Provide an igraph-config.cmake file in the installation directory so
# users can find the installed igraph library with FIND_PACKAGE(igraph)
# from their CMakeLists.txt files
include(CMakePackageConfigHelpers)
configure_package_config_file(
  ${PROJECT_SOURCE_DIR}/etc/cmake/igraph-config.cmake.in
  ${PROJECT_BINARY_DIR}/igraph-config.cmake
  # Install destination selected according to https://wiki.debian.org/CMake
  # and by looking at how eigen3 does it in Ubuntu
  INSTALL_DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/igraph
)

=== debian/changelog ===
igraph (0.10.15+ds-3build1) questing; urgency=medium

  * No-change rebuild for libxml2 soname change.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 21 May 2025 10:04:30 +0200

igraph (0.10.15+ds-3) unstable; urgency=medium

  * Debianization:
    - d/rules:
      - override_dh_auto_build-indep target, now globally rename
        `igraph-docs.info` to `igraph.info` (thanks to Aymeric
        Agon-Rambosson <aymeric.agon@yandex.com> for pointing out
        the issue);
    - d/control:
      - Standards-Version, dump to 4.7.2 (no change);

 -- Jerome Benoit <calculus@rezozer.net>  Sun, 09 Mar 2025 16:12:59 +0000

igraph (0.10.15+ds-2) unstable; urgency=medium

  * Debianization:
    - d/rules:
      - DEB_BUILD_OPTIONS, disable LTO build (Closes: #1092834);
    - d/adhoc/examples/simple/Makefile, hardden (thanks to Matthias
      Klose <matthias.klose@canonical.com> for reporting the issue);
    - various minor janitorial changes.

 -- Jerome Benoit <calculus@rezozer.net>  Sat, 18 Jan 2025 23:34:52 +0000

igraph (0.10.15+ds-1) unstable; urgency=medium

  * New upstream micro version.
  * Debianization:
    - d/libigraph3t64.symbols, update;
    - d/patches/*:
      - d/p/upstream-silence-tests-benchmarks-*.patch, integrated;
    - d/control:
      - Standards-Version, dump to 4.7.0 (no change);
    - d/libigraph-doc.docs, refresh;

 -- Jerome Benoit <calculus@rezozer.net>  Sun, 10 Nov 2024 04:24:30 +0000

=== debian/control ===
--- 
+++ 
@@ -26,7 +26,7 @@
                      libxml2-utils,
                      docbook2x,
                      texinfo
-Standards-Version: 4.6.2
+Standards-Version: 4.7.2
 Vcs-Browser: https://salsa.debian.org/med-team/igraph
 Vcs-Git: https://salsa.debian.org/med-team/igraph.git
 Homepage: https://igraph.org/c/

=== debian/watch ===
version=4
opts="repacksuffix=+ds,dversionmangle=s/\+ds[\d]?//,repack,compression=xz,searchmode=plain" \
	https://api.github.com/repos/igraph/igraph/releases \
	https://github.com/igraph/igraph/releases/download/\d[\.\d]*/igraph-(\d[\d.-]+)\.tar\.gz

## igraph 0.10.16+ds

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -240,6 +240,7 @@
   operators/join.c
   operators/misc_internal.c
   operators/permute.c
+  operators/products.c
   operators/reverse.c
   operators/rewire.c
   operators/rewire_edges.c
@@ -332,7 +333,7 @@
 add_dependencies(igraph parsersources)
 
 # Set soname for the library
-set_target_properties(igraph PROPERTIES VERSION "3.1.9")
+set_target_properties(igraph PROPERTIES VERSION "3.1.10")
 set_target_properties(igraph PROPERTIES SOVERSION 3)
 
 # Add extra compiler definitions if needed
@@ -452,5 +453,3 @@
   ${PROJECT_BINARY_DIR}/igraph-config.cmake
   # Install destination selected according to https://wiki.debian.org/CMake
   # and by looking at how eigen3 does it in Ubuntu
-  INSTALL_DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/igraph
-)

=== tests/CMakeLists.txt ===
include(test_helpers)
include(benchmark_helpers)

add_library(test_utilities OBJECT unit/test_utilities.c)
target_link_libraries(test_utilities PRIVATE igraph)
use_all_warnings(test_utilities)

# Add a compatibility alias to the "test" target so it can also be invoked as
# "make check" - for people who have it in their muscle memories from autotools
add_custom_target(build_tests)
add_custom_target(
  check
  COMMAND ${CMAKE_CTEST_COMMAND} --progress --output-on-failure -C $<CONFIG>
  COMMENT "Executing unit tests..."
  USES_TERMINAL
)
add_dependencies(check build_tests)

# Add a custom target for benchmarks and another one for building them
add_custom_target(build_benchmarks)
add_custom_target(
  benchmark
  COMMENT "Running benchmarks..."
)
add_dependencies(benchmark build_benchmarks)

# Some newer gcc version have --enable-new-dtags on by default. This then leads
# to using RUNPATH instead of RPATH. Since RUNPATH is only considered after
# LD_LIBRARY_PATH, if another version of igraph is installed somewhere it will
# be linked to that library.
include(CheckLinkerFlag)
check_linker_flag(C "-Wl,--enable-new-dtags" HAVE_ENABLE_NEW_DTAGS)
if (HAVE_ENABLE_NEW_DTAGS AND BUILD_SHARED_LIBS)
  message(STATUS "Disabling new dtags for testing to use RPATH to ensure the correct library is found.")
  set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,--disable-new-dtags")
endif()

# tutorial examples and other snippets from the documentation
add_examples(
  FOLDER examples/tutorial NAMES
  tutorial1
  tutorial2
  tutorial3
)

# version.at
add_examples(
  FOLDER examples/simple NAMES
  igraph_version
)

# types.at
add_examples(
  FOLDER examples/simple NAMES
  dqueue
  igraph_sparsemat
  igraph_sparsemat3
  igraph_sparsemat4
  igraph_sparsemat6
  igraph_sparsemat7
  igraph_sparsemat8
  igraph_strvector
  igraph_vector_int_list_sort
)

add_legacy_tests(
  FOLDER tests/unit NAMES
  bitset
  heap
  igraph_complex
  igraph_psumtree
  igraph_sparsemat5
  igraph_sparsemat9
  igraph_sparsemat_droptol
  igraph_sparsemat_fkeep
  igraph_sparsemat_getelements_sorted
  igraph_sparsemat_is_symmetric
  igraph_sparsemat_iterator_idx
  igraph_sparsemat_minmax
  igraph_sparsemat_nonzero_storage
  igraph_sparsemat_normalize
  igraph_sparsemat_view
  igraph_sparsemat_which_minmax
  igraph_strvector
  igraph_vector_floor
  igraph_vector_lex_cmp
  matrix
  matrix2
  matrix3
  matrix_complex
  stack
  strvector_set_len_remove_print
  vector
  vector2
  vector3
  vector4
  vector_list
  vector_ptr
  vector_ptr_sort_ind
  vector_sort_ind
)

if ((NOT BUILD_SHARED_LIBS) OR (NOT BLAS_IS_VENDORED AND NOT ARPACK_IS_VENDORED))
  add_legacy_tests(
    FOLDER tests/unit NAMES
    igraph_sparsemat2 # Uses ARPACK and BLAS functions which are not publicly available when building with internal ARPACK/BLAS
  )
endif()

add_legacy_tests(
  FOLDER tests/unit NAMES
  2wheap
  cutheap
  d_indheap
  marked_queue
  gen2wheap
  set
  trie
)

# basic.at
add_examples(
  FOLDER examples/simple NAMES
  creation
  igraph_copy
  igraph_degree
  igraph_delete_edges
  igraph_delete_vertices
  igraph_get_eid
  igraph_get_eids
  igraph_is_directed
  igraph_neighbors
)

add_legacy_tests(
  FOLDER tests/unit NAMES
  adj
  igraph_add_edges
  igraph_add_vertices
  igraph_degree
  igraph_delete_edges
  igraph_delete_vertices
  igraph_edges
  igraph_empty
  igraph_get_eid
  igraph_is_same_graph
  igraph_i_incident
  igraph_i_neighbors
  igraph_neighbors
)

# iterators.at
add_examples(
  FOLDER examples/simple NAMES
  igraph_es_pairs
  igraph_vs_nonadj
  igraph_vs_range
  igraph_vs_vector
)

add_legacy_tests(
  FOLDER tests/unit NAMES
  edge_selectors
  igraph_es_path
  igraph_es_all_between
  vertex_selectors
)

# structure_generators.at
add_examples(
  FOLDER examples/simple NAMES
  igraph_adjacency
  igraph_atlas
  igraph_barabasi_game
  igraph_barabasi_game2
  igraph_create
  igraph_degree_sequence_game
  igraph_erdos_renyi_game_gnm
  igraph_erdos_renyi_game_gnp
  igraph_full
  igraph_grg_game
  igraph_kary_tree
  igraph_lcf
  igraph_realize_degree_sequence
  igraph_regular_tree
  igraph_ring
  igraph_small
  igraph_star
  igraph_symmetric_tree
  igraph_weighted_adjacency
)

add_legacy_tests(
  FOLDER tests/unit NAMES
  constructor-failure
  erdos_renyi_game_gnm
  erdos_renyi_game_gnp
  full
  igraph_adjacency
  igraph_atlas
  igraph_barabasi_aging_game
  igraph_barabasi_game
  igraph_bipartite_game
  igraph_callaway_traits_game
  igraph_chung_lu_game
  igraph_circulant
  igraph_cited_type_game
  igraph_citing_cited_type_game
  igraph_correlated_game
  igraph_correlated_pair_game
  igraph_create
  igraph_degree_sequence_game
  igraph_dot_product_game
  igraph_establishment_game
  igraph_extended_chordal_ring
  igraph_forest_fire_game
  igraph_from_prufer
  igraph_full_citation
  igraph_full_multipartite
  igraph_generalized_petersen
  igraph_grg_game
  igraph_growing_random_game
  igraph_hsbm_game
  igraph_hsbm_list_game
  igraph_k_regular_game
  igraph_lastcit_game
  igraph_linegraph
  igraph_kautz
  igraph_preference_game
  igraph_perfect
  igraph_realize_degree_sequence
  igraph_recent_degree_aging_game
  igraph_recent_degree_game
  igraph_sbm_game
  igraph_simple_interconnected_islands_game
  igraph_square_lattice
  igraph_static_power_law_game
  igraph_tree_from_parent_vector
  igraph_trussness
  igraph_turan
  igraph_wheel
  igraph_weighted_adjacency
  kary_tree
  symmetric_tree
  tree_game
  ring
  watts_strogatz_game
)

# structural_properties.at
add_examples(
  FOLDER examples/simple NAMES
  bellman_ford
  distances
  igraph_assortativity_degree
  igraph_assortativity_nominal
  igraph_average_path_length
  igraph_cocitation
  igraph_diameter
  igraph_eccentricity
  igraph_feedback_arc_set
  igraph_feedback_arc_set_ip
  igraph_get_all_shortest_paths_dijkstra
  igraph_get_shortest_paths
  igraph_get_shortest_paths_dijkstra
  igraph_girth
  igraph_has_multiple
  igraph_is_loop
  igraph_is_multiple
  igraph_list_triangles
  igraph_avg_nearest_neighbor_degree
  igraph_minimum_spanning_tree
  igraph_pagerank
  igraph_radius
  igraph_reciprocity
  igraph_similarity
  igraph_simplify
  igraph_topological_sorting
  igraph_transitivity
)

add_legacy_tests(
  FOLDER tests/unit NAMES
  all_shortest_paths
  assortativity
  igraph_product
  components
  coreness
  efficiency
  global_transitivity
  harmonic_centrality
  hub_and_authority
  igraph_count_adjacent_triangles
  igraph_are_connected
  igraph_average_path_length
  igraph_average_path_length_dijkstra
  igraph_betweenness
  igraph_betweenness_subset
  igraph_closeness
  igraph_constraint
  igraph_convergence_degree
  igraph_count_multiple
  igraph_density
  igraph_diameter
  igraph_diameter_dijkstra
  igraph_diversity
  igraph_distances_floyd_warshall
  igraph_distances_floyd_warshall_speedup
  igraph_distances_johnson
  igraph_ecc
  igraph_eccentricity
  igraph_eccentricity_dijkstra
  igraph_edge_betweenness
  igraph_edge_betweenness_subset
  igraph_feedback_arc_set
  igraph_feedback_vertex_set
  igraph_get_all_simple_paths
  igraph_get_all_shortest_paths_dijkstra
  igraph_get_k_shortest_paths
  igraph_get_shortest_paths2
  igraph_get_shortest_path_astar
  igraph_get_shortest_path_bellman_ford
  igraph_get_shortest_paths_bellman_ford
  igraph_get_shortest_paths_dijkstra
  igraph_graph_center
  igraph_has_mutual
  igraph_is_bipartite
  igraph_is_connected
  igraph_is_chordal
  igraph_is_clique
  igraph_is_complete
  igraph_is_dag
  igraph_is_mutual
  igraph_is_tree
  igraph_is_forest
  igraph_is_forest2
  igraph_joint_degree_distribution
  igraph_joint_type_distribution
  igraph_is_acyclic
  igraph_list_triangles
  igraph_local_scan_k_ecount
  igraph_local_scan_k_ecount_them
  igraph_local_scan_subset_ecount
  igraph_local_transitivity
  igraph_mean_degree
  igraph_neighborhood
  igraph_neighborhood_graphs
  igraph_neighborhood_size
  igraph_pagerank
  igraph_path_length_hist
  igraph_pseudo_diameter
  igraph_pseudo_diameter_dijkstra
  igraph_random_walk
  igraph_rewire # Uses internal igraph_i_rewire
  igraph_simple_cycles
  igraph_similarity
  igraph_transitive_closure
  igraph_transitivity_avglocal_undirected
  igraph_transitivity_barrat
  igraph_unfold_tree
  igraph_voronoi
  igraph_widest_paths
  igraph_spanner
  knn
  paths
  random_spanning_tree
  reachability
  single_target_shortest_path
  topological_sorting
)

add_legacy_tests(
  FOLDER tests/regression NAMES
  bug_1760
  bug_1814
  bug_1970
  bug_2150
  bug_2497
  bug_2506
  bug_2517
)

# components.at
add_examples(
  FOLDER examples/simple NAMES
  igraph_biconnected_components
  igraph_decompose
  igraph_is_biconnected
)

add_legacy_tests(
  FOLDER tests/unit NAMES
  igraph_biconnected_components
  igraph_bridges
  igraph_decompose_strong
  igraph_is_biconnected
  igraph_subcomponent
)

# layout.at
add_examples(
  FOLDER examples/simple NAMES
  igraph_layout_reingold_tilford
)

add_legacy_tests(
  FOLDER tests/unit NAMES
  igraph_layout_drl
  igraph_layout_drl_3d
  igraph_layout_bipartite
  igraph_layout_fruchterman_reingold
  igraph_layout_fruchterman_reingold_3d
  igraph_layout_gem
  igraph_layout_graphopt
  igraph_layout_grid
  igraph_layout_kamada_kawai
  igraph_layout_lgl
  igraph_layout_mds
  igraph_layout_merge2
  igraph_layout_merge3
  igraph_layout_random_3d
  igraph_layout_reingold_tilford_circular
  igraph_layout_reingold_tilford_extended
  igraph_layout_sphere
  igraph_layout_star
  igraph_layout_sugiyama
  igraph_layout_umap
)
add_legacy_tests(
  FOLDER tests/regression NAMES
  igraph_layout_kamada_kawai_3d_bug_1462
  igraph_layout_reingold_tilford_bug_879
)

add_legacy_tests(
  FOLDER tests/unit NAMES
  igraph_i_layout_sphere
  igraph_layout_davidson_harel # Uses igraph_i_layout_segments_intersect and igraph_i_layout_point_segment_dist2
  igraph_layout_merge # Uses igraph_i_layout_merge functions
  igraph_i_umap_fit_ab
)

# visitors.at
add_examples(
  FOLDER examples/simple NAMES
  igraph_bfs
  igraph_bfs_callback
  igraph_bfs_simple
)
add_legacy_tests(
  FOLDER tests/unit NAMES
  bfs
  bfs_simple
)

# topology.at
add_examples(
  FOLDER examples/simple NAMES
  igraph_isomorphic_vf2
  igraph_subisomorphic_lad
)

add_legacy_tests(
  FOLDER tests/unit NAMES
  simplify_and_colorize
  bliss_automorphisms
  igraph_get_isomorphisms_vf2
  igraph_get_subisomorphisms_vf2
  igraph_isomorphic
  igraph_isomorphic_vf2
  igraph_subisomorphic
  igraph_subisomorphic_lad
  igraph_isomorphic_bliss
  isomorphism_test
  isoclasses
  isoclasses2
  VF2-compat
)

# coloring.at
add_examples(
  FOLDER examples/simple NAMES
  igraph_coloring
)

add_legacy_tests(
  FOLDER tests/unit NAMES
  igraph_coloring
)


# motifs.at
add_examples(
  FOLDER examples/simple NAMES
  igraph_motifs_randesu
)

add_legacy_tests(
  FOLDER tests/unit NAMES
  igraph_dyad_census
  igraph_motifs_randesu
  igraph_motifs_randesu_estimate
  igraph_motifs_randesu_no
  triad_census
)

# foreign.at
add_examples(
  FOLDER examples/simple NAMES
  dot
  foreign
  gml
  graphml
  igraph_read_graph_dl
  igraph_read_graph_graphdb
  igraph_read_graph_lgl
  igraph_write_graph_lgl
  igraph_write_graph_pajek
  safelocale
)

add_legacy_tests(
  FOLDER tests/unit NAMES
  foreign_empty
  gml
  igraph_read_graph_graphdb
  igraph_read_graph_graphml
  igraph_write_graph_leda
  igraph_write_graph_dimacs_flow
  igraph_write_graph_dot
  lineendings
  ncol
  pajek
  pajek2
  pajek_bipartite
  pajek_bipartite2
  pajek_signed
)

# other.at
add_examples(
  FOLDER examples/simple NAMES
  igraph_power_law_fit
)
# igraph_power_law_fit() output is only deterministic when running with 1 thread
set_property(TEST example::igraph_power_law_fit APPEND PROPERTY ENVIRONMENT "OMP_NUM_THREADS=1")

add_legacy_tests(
  FOLDER tests/unit NAMES
  all_almost_e
  cmp_epsilon
  igraph_almost_equals
  igraph_convex_hull
  igraph_power_law_fit
  overflow
  prop_caching
  zapsmall
)
# igraph_power_law_fit() output is only deterministic when running with 1 thread

=== src/cliques/cliquer/CMakeLists.txt ===
# Declare the files needed to compile Cliquer
add_library(
  cliquer
  OBJECT
  EXCLUDE_FROM_ALL
  cliquer.c
  cliquer_graph.c
  reorder.c
)

target_include_directories(
  cliquer
  PRIVATE
  ${PROJECT_SOURCE_DIR}/include
  ${PROJECT_BINARY_DIR}/include
  ${PROJECT_BINARY_DIR}/src
)

if (BUILD_SHARED_LIBS)
  set_property(TARGET cliquer PROPERTY POSITION_INDEPENDENT_CODE ON)
endif()

# Since these are included as object files, they should call the
# function as is (without visibility specification)
target_compile_definitions(cliquer PRIVATE IGRAPH_STATIC)

use_all_warnings(cliquer)

=== debian/changelog ===
igraph (0.10.16+ds-2) unstable; urgency=medium

  * Upload to unstable.
  * Debianization:
    - d/patches/*:
      - d/p/upstream-fix-lintian-spelling_error-silence.patch, introduce.

 -- Jerome Benoit <calculus@rezozer.net>  Sun, 17 Aug 2025 16:45:08 +0000

igraph (0.10.16+ds-1) experimental; urgency=medium

  * New upstream micro version.
  * Debianization:
    - d/patches/*:
      - d/p/upstream-fix-lintian-spelling_error-silence.patch, integrated;
    - d/libigraph3t64.symbols, update;
    - d/a/examples/simple/Makefile, silence deprecation warning
      to ease transition;
    - d/copyright:
      - old-fsf-address-in-copyright-file lintian emit, fix.

 -- Jerome Benoit <calculus@rezozer.net>  Sat, 14 Jun 2025 19:13:19 +0000

=== debian/tests/control ===
Test-Command: debian/tests/check simple
Depends: libigraph-dev, libigraph-doc, locales-all, build-essential, pkgconf

Test-Command: debian/tests/check tutorial
Depends: libigraph-dev, libigraph-doc, build-essential, pkgconf

Test-Command: debian/tests/check benchmarks
Depends: libigraph-dev, libplfit-dev, libigraph-doc, build-essential, pkgconf

## igraph 1.0.0

=== DESCRIPTION ===
Package: igraph
Version: 1.0.0
Title: Network Analysis and Visualization
Author: See AUTHORS file.
Maintainer: Gabor Csardi <csardi.gabor@gmail.com>
Description: Routines for simple graphs and network analysis. It can
    handle large graphs very well and provides functions for generating random
    and regular graphs, graph visualization, centrality methods and much more.
Depends: methods
Imports: Matrix, magrittr, NMF, irlba
Suggests: igraphdata, stats4, rgl, tcltk, graph, ape, scales
License: GPL (>= 2)
URL: http://igraph.org
SystemRequirements: gmp, libxml2
BugReports: https://github.com/igraph/igraph/issues
Collate: 'adjacency.R' 'auto.R' 'assortativity.R' 'attributes.R'
        'basic.R' 'bipartite.R' 'centrality.R' 'centralization.R'
        'cliques.R' 'cocitation.R' 'cohesive.blocks.R' 'printr.R'
        'community.R' 'components.R' 'console.R' 'conversion.R'
        'data_frame.R' 'decomposition.R' 'degseq.R' 'demo.R'
        'embedding.R' 'epi.R' 'fit.R' 'flow.R' 'foreign.R' 'games.R'
        'glet.R' 'hrg.R' 'igraph-package.R' 'incidence.R' 'indexing.R'
        'interface.R' 'iterators.R' 'layout.R' 'layout_drl.R'
        'lazyeval.R' 'make.R' 'mgclust.R' 'minimum.spanning.tree.R'
        'motifs.R' 'nexus.R' 'operators.R' 'other.R' 'package.R'
        'palette.R' 'par.R' 'paths.R' 'plot.R' 'plot.common.R'
        'plot.shapes.R' 'pp.R' 'print.R' 'random_walk.R' 'rewire.R'
        'scan.R' 'scg.R' 'sgm.R' 'similarity.R' 'simple.R' 'sir.R'
        'socnet.R' 'sparsedf.R' 'structural.properties.R'
        'structure.info.R' 'test.R' 'tkplot.R' 'topology.R'
        'triangles.R' 'utils.R' 'uuid.R' 'versions.R' 'weakref.R'
        'zzz-deprecate.R'
NeedsCompilation: yes
Packaged: 2015-06-24 15:29:44 UTC; gaborcsardi
Repository: CRAN
Date/Publication: 2015-06-24 18:47:19

=== src/AMD/Makefile ===
#------------------------------------------------------------------------------
# AMD Makefile (for GNU Make or original make)
#------------------------------------------------------------------------------

VERSION = 2.3.1

default: all

include ../SuiteSparse_config/SuiteSparse_config.mk

demos: all

# Compile all C code.  Do not compile the FORTRAN versions.
all:
	( cd Lib    ; $(MAKE) )
	( cd Demo   ; $(MAKE) )

# compile just the C-callable libraries (not Demos)
library:
	( cd Lib    ; $(MAKE) )

# compile the FORTRAN libraries and demo programs (not compiled by "make all")
fortran:
	( cd Lib    ; $(MAKE) fortran )
	( cd Demo   ; $(MAKE) fortran )

# compile a FORTRAN demo program that calls the C version of AMD
# (not compiled by "make all")
cross:
	( cd Demo   ; $(MAKE) cross )

# remove object files, but keep the compiled programs and library archives
clean:
	( cd Lib    ; $(MAKE) clean )
	( cd Demo   ; $(MAKE) clean )
	( cd MATLAB ; $(RM) $(CLEAN) )
	( cd Doc    ; $(MAKE) clean )

# clean, and then remove compiled programs and library archives
purge:
	( cd Lib    ; $(MAKE) purge )
	( cd Demo   ; $(MAKE) purge )
	( cd MATLAB ; $(RM) $(CLEAN) ; $(RM) *.mex* )
	( cd Doc    ; $(MAKE) purge )

distclean: purge

# create PDF documents for the original distribution
docs:
	( cd Doc    ; $(MAKE) )

# get ready for distribution
dist: purge
	( cd Demo   ; $(MAKE) dist )
	( cd Doc    ; $(MAKE) )

ccode: library

lib: library

# install AMD
install:
	$(CP) Lib/libamd.a $(INSTALL_LIB)/libamd.$(VERSION).a
	( cd $(INSTALL_LIB) ; ln -sf libamd.$(VERSION).a libamd.a )
	$(CP) Include/amd.h $(INSTALL_INCLUDE)
	chmod 644 $(INSTALL_LIB)/libamd*
	chmod 644 $(INSTALL_INCLUDE)/amd.h

# uninstall AMD
uninstall:
	$(RM) $(INSTALL_LIB)/libamd*.a
	$(RM) $(INSTALL_INCLUDE)/amd.h
